var __defProp = Object.defineProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, {
      get: all[name],
      enumerable: true,
      configurable: true,
      set: (newValue) => all[name] = () => newValue
    });
};

// src/string.ts
var exports_string = {};
__export(exports_string, {
  truncate: () => truncate,
  toString: () => toString,
  titleCase: () => titleCase,
  template: () => template,
  str: () => str,
  split: () => split,
  snakeCase: () => snakeCase,
  slug: () => slug,
  slash: () => slash,
  singular: () => singular2,
  sentenceCase: () => sentenceCase,
  random: () => random,
  plural: () => plural2,
  pathCase: () => pathCase,
  pascalCase: () => pascalCase,
  paramCase: () => kebabCase2,
  noCase: () => noCase,
  lowercase: () => lowercase,
  kebabCase: () => kebabCase,
  isSingular: () => isSingular2,
  isPlural: () => isPlural2,
  ensureSuffix: () => ensureSuffix,
  ensurePrefix: () => ensurePrefix,
  dotCase: () => dotCase,
  detectNewline: () => detectNewline,
  detectIndent: () => default2,
  constantCase: () => constantCase,
  capitalize: () => capitalize,
  capitalCase: () => capitalCase,
  camelCase: () => camelCase,
  addUncountableRule: () => addUncountableRule2,
  addSingularRule: () => addSingularRule2,
  addPluralRule: () => addPluralRule2,
  addIrregularRule: () => addIrregularRule2,
  Str: () => Str
});

// src/utils.ts
import slugify from "slugify";
function slash(str) {
  return str.replace(/\\/g, "/");
}
function ensurePrefix(prefix, str) {
  if (!str.startsWith(prefix))
    return prefix + str;
  return str;
}
function ensureSuffix(suffix, str) {
  return str.endsWith(suffix) ? str : str + suffix;
}
function template(str, ...args) {
  return str.replace(/{(\d+)}/g, (match, key) => {
    const index = Number(key);
    return Number.isNaN(index) ? match : args[index];
  });
}
function truncate(str, length, end = "...") {
  if (str.length <= length)
    return str;
  return str.slice(0, length - end.length) + end;
}
function random(size = 16, dict = urlAlphabet) {
  let id = "";
  let i = size;
  const len = dict.length;
  while (i--)
    id += dict[Math.random() * len | 0];
  return id;
}
function slug(str, options) {
  if (options)
    return slugify(str, options);
  return slugify(str, {
    lower: true,
    strict: true
  });
}
import {default as default2} from "detect-indent";
import {detectNewline} from "detect-newline";
var urlAlphabet = "useandom-26T198340PX75pxJACKVERYMINDBUSHWOLF_GQZbfghjklqvwyzrict";
// src/case.ts
function capitalize(str) {
  return str[0] ? str[0].toUpperCase() + str.slice(1).toLowerCase() : "";
}
function lowercase(str) {
  return str.toLowerCase();
}
import {
camelCase,
capitalCase,
constantCase,
dotCase,
noCase,
kebabCase,
kebabCase as kebabCase2,
pascalCase,
pathCase,
sentenceCase,
snakeCase,
split
} from "change-case";
import {titleCase} from "title-case";
// src/pluralize.ts
import * as pluralize from "pluralize";
var plural2 = (word, count, inclusive) => {
  if (count !== undefined && inclusive)
    return `${count} ${pluralize.plural(word)}`;
  return pluralize.plural(word);
};
var singular2 = (word) => pluralize.singular(word);
var isPlural2 = (word) => pluralize.isPlural(word);
var isSingular2 = (word) => pluralize.isSingular(word);
var addPluralRule2 = (rule, replacement) => pluralize.addPluralRule(rule, replacement);
var addSingularRule2 = (rule, replacement) => pluralize.addSingularRule(rule, replacement);
var addIrregularRule2 = (single, plural3) => pluralize.addIrregularRule(single, plural3);
var addUncountableRule2 = (word) => pluralize.addUncountableRule(word);
// src/macro.ts
var Str = {
  slash(str) {
    return slash(str);
  },
  ensurePrefix(prefix, str) {
    return ensurePrefix(prefix, str);
  },
  ensureSuffix(suffix, str) {
    return ensureSuffix(suffix, str);
  },
  template(str, ...args) {
    return template(str, ...args);
  },
  truncate(str, length, end = "...") {
    return truncate(str, length, end);
  },
  random(length = 16) {
    return random(length);
  },
  capitalize(str) {
    return capitalize(str);
  },
  slug(str) {
    return slug(str);
  },
  detectIndent(str) {
    return default2(str);
  },
  detectNewline(str) {
    return detectNewline(str);
  },
  camelCase(str) {
    return camelCase(str);
  },
  capitalCase(str) {
    return capitalCase(str);
  },
  constantCase(str) {
    return constantCase(str);
  },
  dotCase(str) {
    return dotCase(str);
  },
  noCase(str) {
    return noCase(str);
  },
  paramCase(str) {
    return kebabCase2(str);
  },
  pascalCase(str) {
    return pascalCase(str);
  },
  pathCase(str) {
    return pathCase(str);
  },
  sentenceCase(str) {
    return sentenceCase(str);
  },
  snakeCase(str) {
    return snakeCase(str);
  },
  titleCase(str) {
    return titleCase(str);
  },
  kebabCase(str) {
    return kebabCase(str);
  },
  plural(str) {
    return plural2(str);
  },
  singular(str) {
    return singular2(str);
  },
  isPlural(str) {
    return isPlural2(str);
  },
  isSingular(str) {
    return isSingular2(str);
  },
  addPluralRule(rule, repl) {
    return addPluralRule2(rule, repl);
  },
  addSingularRule(rule, repl) {
    return addSingularRule2(rule, repl);
  },
  addIrregularRule(single, plural3) {
    return addIrregularRule2(single, plural3);
  },
  addUncountableRule(word) {
    return addUncountableRule2(word);
  }
};
var str = Str;
// src/helpers.ts
function toString(v) {
  return Object.prototype.toString.call(v);
}
export {
  truncate,
  toString,
  titleCase,
  template,
  exports_string as string,
  str,
  split,
  snakeCase,
  slug,
  slash,
  singular2 as singular,
  sentenceCase,
  random,
  plural2 as plural,
  pathCase,
  pascalCase,
  kebabCase2 as paramCase,
  noCase,
  lowercase,
  kebabCase,
  isSingular2 as isSingular,
  isPlural2 as isPlural,
  ensureSuffix,
  ensurePrefix,
  dotCase,
  detectNewline,
  default2 as detectIndent,
  constantCase,
  capitalize,
  capitalCase,
  camelCase,
  addUncountableRule2 as addUncountableRule,
  addSingularRule2 as addSingularRule,
  addPluralRule2 as addPluralRule,
  addIrregularRule2 as addIrregularRule,
  Str
};
